<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { axisBottom, axisLeft } from "d3-axis";
  import { brush } from "d3-brush";

  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";
  export let myRange = null;

  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));

  // Brushing
  // The range of the selection rectangle.
  // If there is no active selection, it contains: null,
  // otherwise, it contains: [ [x0, y0], [x1, y1] ]
  let range = null;

  function createBrush(g) {
    const myBrush = brush()
     .on("end", brushEnd)
    myBrush(select(g));
  }

  function brushEnd({selection}) {
    console.log(selection);
    myRange = selection;
    coords.forEach(setProps);
  }

  // Coords
  let coords;
  $: coords;
  data.forEach(extractCoordinate)
  function extractCoordinate(value, index, array) {
    if (!coords) {coords = []}
    coords[index] = {x: x(value), y: y(value), stroke: "steelblue", fill: "steelblue", fillOpacity: "0.5", strokeOpacity: "1"};
    // console.log("coords: ", coords[index].x, coords[index].y)
  }

  function setProps(c, index, array) {
    if (!myRange) {
      array[index].stroke = "steelblue";
      array[index].fill = "steelblue";
      array[index].fillOpacity = "0.5";
      array[index].strokeOpacity = "1";
    }
    else {
      let x1 = myRange[0][0];
      let y1 = myRange[0][1];
      let x2 = myRange[1][0];
      let y2 = myRange[1][1];
      if (x1 <= xScale(c.x) && xScale(c.x) <= x2 && y1 <= yScale(c.y) && yScale(c.y) <= y2) {
        console.log("blue", x1, x2, c.x);
        array[index].stroke = "steelblue";
        array[index].fill = "steelblue";
        array[index].fillOpacity = "0.5";
        array[index].strokeOpacity = "1";
      } else {
        console.log("gray");
        array[index].stroke = "darkgray";
        array[index].fill = "darkgray";
        array[index].fillOpacity = "0.3";
        array[index].strokeOpacity = "0.5";
      }
    }
  }
</script>

<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px">
  <g transform="translate({margin.left},{margin.top})">
    <g use:createBrush>
      {#if coords}
        {#each coords as c}
          <circle
            cx={xScale(c.x)}
            cy={yScale(c.y)}
            r={3}
            fill={c.fill}
            fill-opacity={c.fillOpacity}
            stroke={c.stroke}
            stroke-width="1.5"
            stroke-opacity={c.strokeOpacity}
          />
        {/each}
      {/if}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text
      >
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text
      >
    </g>
  </g>
</svg>

<style>
  .axisLabel {
    text-anchor: middle;
    vertical-align: bottom;
    fill: currentcolor;
  }
</style>